/********************************************
* DMM with Delta-Sigma A/D Converter
* PIC16F819@
* SPIʐMI/O[hŎs
* t\̐֐͕ʃCu(lcd_lib2.c)  
**********************************************/
#include    <16F819.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,PUT,BROWNOUT,MCLR,NOCPD,NOLVP 
#use delay(CLOCK = 8000000)			//NbN8MHz
#use fast_io(A)
#use fast_io(B)

////// t\탉Cupݒ
#byte	PORTA = 5
#byte	PORTB = 6
#define	PORTx 		PORTB
#define	stb			PIN_B4			//Mݒ
#define	rs			PIN_B5
#include  <lcd_lib2.c>					//CuCN[h
/// O[oϐ
#define	RedLED		PIN_A7
// SPI PORT definition
#define SPI_CS_IO  		PIN_A2
#define SPI_CLK_IO		PIN_A0
#define SPI_SDI_IO		PIN_A1
#define	BUTTON0_IO		PIN_A3
#define	BUTTON1_IO		PIN_A4
signed int32 MesureData, Temp;			// 22bitvf[^
float Result;
unsigned int i, OverFlow, Key;			// tO
//// vg^CsO
void Mesure(void);
void Display(void);

///// C֐@////////////////////
void main()
{
	/// o̓|[gݒ
	setup_adc_ports(NO_ANALOGS);
	set_tris_a(0x1A);
	set_tris_b(0x0);					//Sso̓[h
	output_high(SPI_CLK_IO);
	output_high(SPI_CS_IO);
	//// t\\
	lcd_init();						//t\평
	lcd_clear();						//S
	printf(lcd_data,"Start!!");		//X^[gbZ[Wo
	delay_ms(500);

	///// C[v ////////////////
	while(1)
	{
/*	fobOp@_łƌvӂ
		/// ڈLEDtbJ
		if(input(RedLED) == 0)
			output_high(RedLED);
		else
			output_low(RedLED);
*/
		/// vs
		Mesure();
		/// tɕ\
		Display();
		delay_ms(200);
	}
}

/*****************************
*  f^VO}A/DRo[^
*  Tu[`
******************************/
void Mesure(void)
{
	/// PϊJn
	output_low(SPI_CS_IO);				// ϊJngK
	delay_cycles(3);
	output_high(SPI_CS_IO);			// gKI
	Delay_us(10);						// 10usecfBC
	output_low(SPI_CS_IO);				// rW[mFp_~[CS
	Delay_us(10);						// 10usec
	output_high(SPI_CS_IO);
	delay_ms(100);
	///////////////////////
	/// f[^
	output_low(SPI_CS_IO);				// f[^͗pfoCXI
	OverFlow = 0;						// f[^NA
	MesureData = 0;
	delay_us(10);						// 10usec҂
	/// I[o[t[tO
	for(i=0; i<2; i++)
	{
		OverFlow = OverFlow << 1;
		output_low(SPI_CLK_IO);		// CLOCK Low
		delay_cycles(3);
		if(input(SPI_SDI_IO))			// 2rbg
			OverFlow ++;
		output_high(SPI_CLK_IO);
	}
	/// 22rbgf[^́iōʃrbg͕j
	for(i=0; i<22; i++)
	{
		MesureData = MesureData << 1;	// PrbgVtg
		output_low(SPI_CLK_IO);		// NbNpXo
		delay_cycles(3);
		if(input(SPI_SDI_IO))
			MesureData ++;			// f[^
		output_high(SPI_CLK_IO);
	}
	output_high(SPI_CS_IO);			// foCXI
	/// f[^vZ 22rbg  32rbgɕϊ(t)
	MesureData = MesureData << 10;
}

/******************************************
/ vʂ̕\Tu[`
/*****************************************/
void Display(void)
{
	lcd_cmd(0x80);					// Home
	printf(lcd_data, "                ");
	lcd_cmd(0x80);
	/// dAdAR̕\
	if(input(BUTTON0_IO))				// dH
	{
		if(input(BUTTON1_IO))			// PO{H
		{
			/// ől4096.00mVɌ킹(tj
			/// 0x7FFFFFFF/409600=0xCCCC
			MesureData = MesureData / 0x147A;
			Result = (float)MesureData / 100;
			/// tɕ\
			printf(lcd_data, "Volt= %4.2f mV", Result);
		}
		else	/// dPO{[h̏ꍇ	
		{
			/// ől40.960VɌ킹@R덷␳܂
			MesureData = MesureData / 0xCA3F;
			/// ɕϊ 
			Result = (float)MesureData / 1000;
			/// tɕ\
			printf(lcd_data, "Volt= %2.3f V", Result);
		}
	}
	else		/// dȐꍇ
	{
		if(input(BUTTON1_IO))		// d̏ꍇH
		{
			/// ől409.6mAɌ킹(0.1̒R̓dʍj
			/// 0x7FFFFFFF/40960 = 0xCCCC
			MesureData = MesureData / 0xCCCC;
			Result = (float)MesureData / 100;
			/// tɕ\
			printf(lcd_data, "Curr= %3.1f mA", Result);
		}
		else  /// Ȑꍇ@@1kɑ΂@V=0x1FFFFF*X/iX+1k)
			  /// vZ X=V*1k/(0x1FFFFF-V)
		{
			MesureData = MesureData >> 10;		// 22bitɖ߂BK
			/// Rl@Ɍ킹@21rbgijŌvZ
			Temp = (0x1FFFFF - MesureData);
			MesureData = (MesureData * 1000)/ Temp;
			Result = (float)MesureData / 1000;
			/// tɕ\
			printf(lcd_data, "R= %3.3f kOhm", Result);	
		}			
	}
}

